﻿using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Controls;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            string[] countryArray = new string[]
            {
                "Afghanistan",
                "Albania",
                "Algeria",
                "Andorra",
                "Angola"
            };

            Record[] recordArray = new Record[countryArray.Length];

            for(int i = 0; i < countryArray.Length; i++)
            {
                recordArray[i] = new Record(countryArray[i]);
            }

            this.lookUpEdit.Properties.DisplayMember = "Country";
            this.lookUpEdit.Properties.ValueMember   = "Country";

            this.lookUpEdit.Properties.Columns.Add(new LookUpColumnInfo("ID"     , "ID"     , 20 ));
            this.lookUpEdit.Properties.Columns.Add(new LookUpColumnInfo("Country", "Country", 100));

            this.lookUpEdit.GetNotInListValue += lookUpEdit_GetNotInListValue;

            this.lookUpEdit.Properties.DataSource = recordArray;

            this.lookUpEdit.EditValue = recordArray[0].Country;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 룩업 에디터 리스트에서 없는 값 구하기 - lookUpEdit_GetNotInListValue(sender, e)

        /// <summary>
        /// 룩업 에디터 리스트에서 없는 값 구하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void lookUpEdit_GetNotInListValue(object sender, GetNotInListValueEventArgs e)
        {
            if(e.FieldName == "ID")
            {
                e.Value = e.RecordIndex.ToString() + ".";
            }
        }

        #endregion
    }
}